
#include "Arduino.h"
#include "nrf.h"
#include "nrf52_pwm.h"	   
    	   
#define MODULATION
#define NSAMPLES 100
uint8_t sorties[4] = {3,4,5,6};
float sinus_1[NSAMPLES];
float sinus_2[NSAMPLES];
uint16_t countertop[NSAMPLES];
uint8_t prescaler = 0; // horloge à 16 MHz
uint16_t ct = 1600; // 10 kHz
uint16_t refresh = 10; // période d'échantillonnage = 1 ms, période = 1 ms*NSAMPLES = 100 ms
uint16_t boucle = 20; // 20 périodes (2 secondes)

NRF52_PWM pwm; 	   
    	   
void setup() {
  Serial.begin(115200);
  for (int i=0; i<4; i++) pinMode(sorties[i],OUTPUT);  
  for (int i=0; i<NSAMPLES; i++) {  
      sinus_1[i] = 0.5+0.4*sin(2*PI*i/NSAMPLES);
      sinus_2[i] = 0.5+0.4*cos(2*PI*i/NSAMPLES);
      fixe[i] = 0.5;
  }
  for (int i=0; i<NSAMPLES/2; i++) countertop[i] = ct;
  for (int i=NSAMPLES/2; i<NSAMPLES; i++) countertop[i] = 1500;
  
}    	   
    	   
#ifndef MODULATION
void loop() {
  float rapports[2] = {0.3,0.5};
  pwm.fixe_quatre_sorties(2,sorties,prescaler,ct,rapports);
  delay(1000);
  pwm.stop();
  delay(1000);
}

    	    
#else
void loop() {
    pwm.modulation_une_sortie(sorties[0],prescaler,refresh,NSAMPLES,boucle,ct,sinus_1);
    //pwm.modulation_deux_sorties(sorties[0],sorties[1],prescaler,refresh,NSAMPLES,boucle,ct,sinus_1,sinus_2);
    //pwm.modulation_quatre_sorties(sorties[0],sorties[1],sorties[2],sorties[2],prescaler,refresh,NSAMPLES,boucle,ct,sinus_1,sinus_2,sinus_1,sinus_2);
    //pwm.modulation_trois_sorties_fmod(3,sorties,prescaler,refresh,NSAMPLES,boucle,countertop,fixe,sinus_1,sinus_2);
    pwm.attendre();
    pwm.stop();
    delay(1000);
}
#endif
    	     